#ifndef THREAD_H
#define THREAD_H

#include <iostream>
#include <map>
#include <SDL_thread.h>

class Thread
{
public:
    Thread();
    virtual ~Thread();// Arrte automatiquement le thread meme s'il est en cours.
    bool start();// Dmarre la fonction run() dans un thread.
    void stop();// Arrte le thread.
    void join();// Rattache le thread au processus principal qui est bloqu et attend que le run() se termine.
    void setAutoDelete(bool autoDelete);// Permet de declarer dynamiquement une classe qui hrite de Thread sans garder le pointeur, il sera delete automatiquement  la fin du thread si l'argument est true.

    bool threadRunning();

    bool lockMutex(std::string name);
    bool unlockMutex(std::string name);

    virtual void run() = 0;// Tout devra se passer ici

protected:
    bool createLockMutex(std::string name);

private:
    static int ThreadInit(void* param);
    bool m_isstop;
    SDL_Thread *m_t;
    bool m_autoDelete;
    std::map<std::string, SDL_mutex*> m_mutexs;
};

#endif // THREAD_H
